"use strict";

var _crypto = _interopRequireDefault(require("crypto"));

var _rssParser = _interopRequireDefault(require("rss-parser"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const createContentDigest = obj => _crypto.default.createHash(`md5`).update(JSON.stringify(obj)).digest(`hex`);

exports.sourceNodes = async ({
  actions,
  createNodeId
}, {
  url,
  name
}) => {
  const {
    createNode
  } = actions;
  const parser = new _rssParser.default();
  const feed = await parser.parseURL(url);
  feed.items.forEach(item => {
    const nodeId = createNodeId(item.link);
    createNode({ ...item,
      id: nodeId,
      parent: null,
      children: [],
      internal: {
        contentDigest: createContentDigest(item),
        type: `Feed${name}`
      }
    });
  });
};